package ReferenceData;

public class NFC_PROTOCOL_STATUS {
	public enum PROTOCOL_18092
	{
		ATR_RES((byte)0x01),  // Attribute Request CMD2 Byte
        WUP_RES((byte)0x03),  // Wakeup Request CMD2 Byte
        PSL_RES((byte)0x05),  // Parameter Selection Request CMD2 Byte
        DEP_RES((byte)0x07),  // Data Exchange Protocol Request CMD2 Byte
        DSL_RES((byte)0x09),  // Deselect Request CMD2 Byte
        RLS_RES((byte)0x0B),  // Release Request CMD2 Byte

        ATR_REQ((byte)0x00),  // Attribute Response CMD2 Byte
        WUP_REQ((byte)0x02),  // Wakeup Response CMD2 Byte
        PSL_REQ((byte)0x04),  // Parameter Selection Response CMD2 Byte
        DEP_REQ((byte)0x06),  // Data Exchange Protocol Response CMD2 Byte
        DSL_REQ((byte)0x08),  // Deselect Response CMD2 Byte
        RLS_REQ((byte)0x0A);  // Release Response CMD2 Byte
	        
	    private byte id;
	    PROTOCOL_18092(byte byteId) {this.id = byteId;}
	    public byte getProtocol18092() {return id;}
	    
	    public static PROTOCOL_18092 getKeyNameProtocol18092(byte byteProtocol18092)
	    {
	    	for (PROTOCOL_18092 protocol18092 : PROTOCOL_18092.values()) 
	    	{
	            if (protocol18092.id == byteProtocol18092)
	            	return protocol18092;
	        }
	    	
	    	return ATR_REQ;
	    }
	}
	
	public enum CONNECTION_STATUS
	{
		RECEIVE_DIAL((byte)0x00),
        RECEIVE_CONNECTED((byte)0x01),
        RECEIVE_FINISHED((byte)0x02),
        RECEIVE_DISCONNECTED((byte)0x03);
	        
	    private byte id;
	    CONNECTION_STATUS(byte byteId) {this.id = byteId;}
	    public byte getConnectionStatus() {return id;}
	    public static CONNECTION_STATUS getKeyNameConnectionStatus(byte byteConnectionStatus)
	    {
	    	for (CONNECTION_STATUS connectionStatus : CONNECTION_STATUS.values()) 
	    	{
	            if (connectionStatus.id == byteConnectionStatus) 
	            	return connectionStatus;
	        }
	    	
	    	return RECEIVE_DIAL;
	    }
	}
	
	public enum LLC_TYPE
	{
		SYMMETRY((byte)0x00),
        PARAMETER_EXCHANGE((byte)0x01),
        AGGREGATED_FRAME((byte)0x02),
        UNNUMBERED_INFORMATION((byte)0x03),
        CONNECT((byte)0x04),
        DISCONNECT((byte)0x05),
        CONNECTION_COMPLETE((byte)0x06),
        DISCONNECTED_MODE((byte)0x07),
        FRAME_REJECT((byte)0x08),
        SERVICE_NAME_LOOKUP((byte)0x09),
        INFORMATION((byte)0x0C),
        RECEIVE_READY((byte)0x0D),
        RECEIVE_NOT_READY((byte)0x0E);
	        
	    private byte id;
	    LLC_TYPE(byte byteId) {this.id = byteId;}
	    public byte getLLCType() {return id;}
	    
	    public static LLC_TYPE getKeyNameLLCType(byte byteLlcType)
	    {
	    	for (LLC_TYPE llcType : LLC_TYPE.values()) 
	    	{
	            if (llcType.id == byteLlcType) 
	            	return llcType;
	        }
	    	
	    	return SYMMETRY;
	    }
	}
}
