import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

import java.awt.*;

@SuppressWarnings("serial")
class JTextFieldLimit extends PlainDocument {
	private int limit;
	private Component parent;

	JTextFieldLimit(int limit, Component parent) {
		super();
		this.parent = parent;
		this.limit = limit;
	}

	public void insertString(int offset, String str, AttributeSet attr)
	throws BadLocationException {
		
		int currentTextLength;
		int newTextLength;
		int length;
		
		if (str == null)
			return;
		
		currentTextLength = getLength();
		newTextLength = currentTextLength + str.length();

		if (newTextLength <= limit)
		{
			super.insertString(offset, str, attr);
		}		
		else if(str.length() > 1)
		{
			length = limit - currentTextLength;
			super.insertString(offset, str.substring(0, length), attr);
		}
		else if (parent != null)
		{
			this.parent.getToolkit().beep();
		}
	}
};
