/*
  Copyright(C):      Advanced Card Systems Ltd

  File:              mainApplet.java

  Description:       This program enables the user to browse the sample codes for ACR122

  Author:            M.J.E.C. Castillo

  Date:              August 4, 2008

  Revision Trail:   (Date/Author/Description)

======================================================================*/

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.ParseException;

import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

@SuppressWarnings("serial")
public class MainApplet extends JApplet implements ActionListener
{
	public MainApplet() {}
	
	// Variables
	boolean _isMifareNdefOpen = false;

	//GUI Variables
    private JButton _ButtonNtag203Ndef;
	
	static Ntag203Ndef _ntagNdef;

	public void init() 
   	{
		JLabel LabelMifareNdefSampleCode;
		
		setSize(230,120);
		_ButtonNtag203Ndef = new JButton();
		_ButtonNtag203Ndef.setFont(new Font("Verdana", Font.PLAIN, 10));
		_ButtonNtag203Ndef.setBounds(10, 44, 210, 23);

		_ButtonNtag203Ndef.setText("NTAG203 NDEF Sample Code");
        
        LabelMifareNdefSampleCode = new JLabel("NDEF Sample Code");
        LabelMifareNdefSampleCode.setHorizontalAlignment(SwingConstants.CENTER);
        LabelMifareNdefSampleCode.setFont(new Font("Verdana", Font.PLAIN, 10));
        LabelMifareNdefSampleCode.setBounds(10, 19, 210, 14);
        
        getContentPane().setLayout(null);
        getContentPane().add(LabelMifareNdefSampleCode);
        getContentPane().add(_ButtonNtag203Ndef);
        
        _ButtonNtag203Ndef.addActionListener(this);
   		
   	}
	
	public void actionPerformed(ActionEvent e) 
	{		
		if(_ButtonNtag203Ndef == e.getSource())
		{
			closeFrames();
			
			if(_isMifareNdefOpen == false)
			{
				try {
					_ntagNdef = new Ntag203Ndef();
				} catch (ParseException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				
				_ntagNdef.setVisible(true);
				_isMifareNdefOpen = true;
			}
			else
			{			
				_ntagNdef.dispose();
				
				try {
					_ntagNdef = new Ntag203Ndef();
				} catch (ParseException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				
				_ntagNdef.setVisible(true);
				_isMifareNdefOpen = true;
			}			
		}
	}
	
	public void closeFrames()
	{		
		if(_isMifareNdefOpen == true)
		{
			_ntagNdef.dispose();
			_isMifareNdefOpen = false;
		}		
	}
	
	public void start()
	{
	
	}
}