
public class Ntag203 {
	
	private PcscReader _pcscConnection;
    public PcscReader getPcscConnection(){return this._pcscConnection;}
    public void setPcscConnection(PcscReader pcscReader) { this._pcscConnection = pcscReader; }
    
	public Ntag203(PcscReader pcscConnection)
    {
        _pcscConnection = pcscConnection;
    }

    public byte[] readBinary(byte blockNumber, byte length) throws Exception
    {
        Apdu apdu;
        byte[] tmpArray = new byte[length];
        
        apdu = new Apdu();
        apdu.setCommand(new byte[] { (byte)0xFF, (byte)0xB0, 0x00, blockNumber, length });
        apdu.setLengthExpected(length);

        getPcscConnection().sendApduCommand(apdu);	
        
        if(apdu.getSw()[0] != (byte)0x90)
            throw new Exception("Read failed");
        
        System.arraycopy(apdu.getReceiveData(), 0, tmpArray, 0, length);

        return tmpArray;
    }
    
    public void updateBinary(byte blockNumber, byte[] data, byte length) throws Exception
    {
        Apdu apdu;

        if (data.length != length)
            throw new Exception("Data has invalid length");

        if (length % 4 != 0)
        {
            throw new Exception("Data length must be multiple of 4");
        }

        apdu = new Apdu();
        apdu.setCommand(new byte[] {(byte) 0xFF, (byte)0xD6, 0x00, blockNumber, length });

        apdu.setSendData(new byte[data.length]);
        apdu.setSendData(data);

        getPcscConnection().sendApduCommand(apdu);
		
		if(apdu.getSw()[0] != (byte)0x90)
            throw new Exception("Update failed");
    }

}
