

/*===========================================================================================
 * 
 *  Copyright (C)   : Advanced Card System Ltd
 * 
 *  File            : Acr89UA2.java
 * 
 *  Description     : 
 * 
 *  Author          : Charlotte Morfe
 *  
 *  Date            : 
 * 
 *  Revision Trail  : [Author] / [Date if modification] / [Details of Modifications done] 
 * 
 * =========================================================================================*/

public class ReaderFunctions
{		
	//private PcscReader pcscReader = new PcscReader();
	private PcscReader _pcscReader;
	
	public PcscReader getPcscConnection() {return this._pcscReader;}
	public void setPcscConnection(PcscReader pcscConnection) {this._pcscReader = pcscConnection;}
	
	public ReaderFunctions(PcscReader pcscReader)
	{
		this._pcscReader = pcscReader;
	}
	
	public enum CHIP_TYPE
	{
		UNKNOWN (0), MIFARE_1K (1), MIFARE_4K (2);		
		private CHIP_TYPE(int value)
		{
		}		
	};	
	
	public enum KEY_STRUCTURE
	{
		VOLATILE((byte)0x00), NON_VOLATILE((byte)0x20);		
		private KEY_STRUCTURE (byte value)
		{
		}
	};
	
	public enum KEYTYPES
	{
		ACR122_KEYTYPE_A(0x60),
        ACR122_KEYTYPE_B(0x61);
		
		private final int _id;
		KEYTYPES(int id) {this._id = id;}
	}
	
	public boolean loadAuthKey(byte[] key,  byte keyNumber) throws Exception
        {
            Apdu apdu;
            
            if(keyNumber > 0x01)    	    			 
    		    throw new Exception("Key number is invalid");      		    	    		       

            if (key.length != 6)
                throw new Exception("Invalid key length");

            apdu = new Apdu();
            apdu.setCommand(new byte[] { (byte)0xFF, (byte)0x82, 0x00, (byte)keyNumber, (byte)0x06 });
            apdu.setSendData(key);
            apdu.setLengthExpected((byte) 0x02);

            getPcscConnection().sendApduCommand(apdu);
       
            if (apdu.getSw()[0] != (byte)0x90)
                return false;

            return true;
    }

    public boolean authenticate(byte blockNum, KEYTYPES keyType, byte KeyNum) throws Exception
    {
        Apdu apdu;

        if (KeyNum > 0x20)
            throw new Exception("Key number is invalid");

        apdu = new Apdu();
        apdu.setCommand(new byte[] { (byte)0xFF, (byte)0x86, (byte)0x00, (byte)0x00, (byte)0x05 });
        apdu.setSendData(new byte[] { (byte)0x01, (byte)0x00, (byte)blockNum, (byte)keyType._id, (byte)KeyNum });
        
        getPcscConnection().sendApduCommand(apdu);

        if (apdu.getSw()[0] != (byte)0x90)
            return false;

        return true;
    }
}
