﻿Imports Mifare_NDEF_Sample_Code.Acs.Readers.Pcsc

Public Enum VALUEBLOCKOPERATION
    STORE = 0
    INCREMENT = 1
    DECREMENT = 2
End Enum

Public Class MifareClassic

    Private _pcscConnection As PcscReader
    Private apdu As Apdu

    Public Sub New()
    End Sub

    Public Sub New(ByVal readerName As String)
        _pcscConnection = New PcscReader(readerName)
    End Sub

    Public Sub New(ByVal pcsc As PcscReader)
        _pcscConnection = pcsc
    End Sub

    Public Property pcscConnection() As PcscReader
        Get
            Return _pcscConnection
        End Get
        Set(ByVal value As PcscReader)
            _pcscConnection = value
        End Set
    End Property

    Private Function getErrorMessage(ByVal sw1sw2 As Byte()) As String
        If (sw1sw2.Length < 2) Then
            Return "Unknown Status Word (" + Helper.byteAsString(sw1sw2, False) + ")"

        ElseIf (sw1sw2(0) = &H63 And sw1sw2(1) = &H0) Then
            Return "Command failed"
        Else
            Return "Unknown Status Word (" + Helper.byteAsString(sw1sw2, False) + ")"
        End If
    End Function

    Public Function isMifareClassic(ByVal atr As Byte()) As Boolean
        If (Not (atr Is Nothing) And atr.Length > 8 And Helper.byteArrayIsEqual(atr.Skip(4).Take(3).ToArray(), New Byte() {&H80, &H4F, &HC})) Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Function readBinary(ByVal blockNumber As Byte, ByVal length As Byte) As Byte()
        Dim apdu As Apdu

        apdu = New Apdu()
        apdu.setCommand(New Byte() {&HFF, &HB0, &H0, blockNumber, length})
        apdu.data = New Byte(-1) {}
        apdu.lengthExpected = length

        pcscConnection.sendCommand(apdu)
        If apdu.statusWord(0) <> &H90 Then
            Return New Byte(-1) {}
        End If
        'throw new CardException("Read failed", apdu.statusWord);

        Return apdu.response.Take(length).ToArray()
    End Function

    Public Function updateBinary(ByVal blockNumber As Byte, ByVal data As Byte(), ByVal length As Byte) As Integer
        Dim apdu As Apdu

        If data.Length > 48 Then
            Throw New Exception("Data has invalid length")
        End If

        If length Mod 16 <> 0 Then
            Throw New Exception("Data length must be multiple of 16")
        End If

        'if (data.Length != 16)
        '    Array.Resize(ref data, 16);

        apdu = New Apdu()
        apdu.setCommand(New Byte() {&HFF, &HD6, &H0, blockNumber, length})

        apdu.data = New Byte(data.Length - 1) {}
        Array.Copy(data, apdu.data, length)

        pcscConnection.sendCommand(apdu)

        If apdu.statusWord(0) <> &H90 Then
            Return -1
        End If
        'throw new CardException("Update failed", apdu.statusWord);

        Return 0
    End Function

End Class
