﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text


Namespace Acs.Readers.Pcsc
    Public Class CardSelector

        Private pcscReader_ As PcscReader
        Public Property pcscReader() As PcscReader
            Get
                Return Me.pcscReader_
            End Get
            Set(ByVal value As PcscReader)
                Me.pcscReader_ = value
            End Set
        End Property

        Public Function readCardType(ByVal atr As Byte(), ByVal atrLen As Byte) As String
            Dim aRid As Byte() = New Byte() {&HA0, &H0, &H0, &H3, &H6}
            Dim aCardIdentifier As Byte() = New Byte(1) {}
            Dim aUid As Byte() = New Byte(299) {}
            Dim sCardName As String = "Unknown"

            ' Check if Part 3 or Part 4
            If atr(4) = &H80 AndAlso atr(5) = &H4F Then
                ' Part 3
                ' Check RID                
                If aRid.SequenceEqual(atr.Skip(7).Take(5).ToArray()) Then
                    ' Get Card Name
                    Array.Copy(atr, 13, aCardIdentifier, 0, 2)

                    Select Case aCardIdentifier(1)
                        Case 0
                            sCardName = "Unknown"
                            Exit Select
                        Case 1
                            sCardName = "Mifare Standard 1K"
                            Exit Select
                        Case 2
                            sCardName = "Mifare Standard 4K"
                            Exit Select
                        Case 3
                            'sCardName = "Mifare Ultralight"
                            sCardName = "NTAG203"
                            Exit Select
                        Case 4
                            sCardName = "SLE55R_XXXX"
                            Exit Select
                        Case 6
                            sCardName = "SR176"
                            Exit Select
                        Case 7
                            sCardName = "SRI X4K"
                            Exit Select
                        Case 8
                            sCardName = "AT88RF020"
                            Exit Select
                        Case 9
                            sCardName = "AT88SC0204CRF"
                            Exit Select
                        Case 10
                            sCardName = "AT88SC0808CRF"
                            Exit Select
                        Case 11
                            sCardName = "AT88SC1616CRF"
                            Exit Select
                        Case 12
                            sCardName = "AT88SC3216CRF"
                            Exit Select
                        Case 13
                            sCardName = "AT88SC6416CRF"
                            Exit Select
                        Case 14
                            sCardName = "SRF55V10P"
                            Exit Select
                        Case 15
                            sCardName = "SRF55V02P"
                            Exit Select
                        Case 16
                            sCardName = "SRF55V10S"
                            Exit Select
                        Case 17
                            sCardName = "SRF55V02S"
                            Exit Select
                        Case 18
                            sCardName = "TAG IT"
                            Exit Select
                        Case 19
                            sCardName = "LR1512"
                            Exit Select
                        Case 20
                            sCardName = "ICODESLI"
                            Exit Select
                        Case 21
                            sCardName = "TEMPSENS"
                            Exit Select
                        Case 22
                            sCardName = "I.CODE1"
                            Exit Select
                        Case 23
                            sCardName = "PicoPass 2K"
                            Exit Select
                        Case 24
                            sCardName = "PicoPass 2KS"
                            Exit Select
                        Case 25
                            sCardName = "PicoPass 16K"
                            Exit Select
                        Case 26
                            sCardName = "PicoPass 16Ks"
                            Exit Select
                        Case 27
                            sCardName = "PicoPass 16K(8x2)"
                            Exit Select
                        Case 28
                            sCardName = "PicoPass 16Ks(8x2)"
                            Exit Select
                        Case 29
                            sCardName = "PicoPass 32KS(16+16)"
                            Exit Select
                        Case 30
                            sCardName = "PicoPass 32KS(16+8x2)"
                            Exit Select
                        Case 31
                            sCardName = "PicoPass 32KS(8x2+16)"
                            Exit Select
                        Case 32
                            sCardName = "PicoPass 32KS(8x2+8x2)"
                            Exit Select
                        Case 33
                            sCardName = "LRI64"
                            Exit Select
                        Case 34
                            sCardName = "I.CODE UID"
                            Exit Select
                        Case 35
                            sCardName = "I.CODE EPC"
                            Exit Select
                        Case 36
                            sCardName = "LRI12"
                            Exit Select
                        Case 37
                            sCardName = "LRI128"
                            Exit Select
                        Case 38
                            sCardName = "Mifare Mini"
                            Exit Select
                        Case 39
                            sCardName = "my-d move (SLE 66R01P)"
                            Exit Select
                        Case 40
                            sCardName = "my-d NFC (SLE 66RxxP)"
                            Exit Select
                        Case 41
                            sCardName = "my-d proximity 2 (SLE 66RxxS)"
                            Exit Select
                        Case 42
                            sCardName = "my-d proximity enhanced (SLE 55RxxE)"
                            Exit Select
                        Case 43
                            sCardName = "my-d light (SRF 55V01P))"
                            Exit Select
                        Case 44
                            sCardName = "PJM Stack Tag (SRF 66V10ST)"
                            Exit Select
                        Case 45
                            sCardName = "PJM Item Tag (SRF 66V10IT)"
                            Exit Select
                        Case 46
                            sCardName = "PJM Light (SRF 66V01ST)"
                            Exit Select
                        Case 47
                            sCardName = "Jewel Tag"
                            Exit Select
                        Case 48
                            sCardName = "Topaz NFC Tag"
                            Exit Select
                        Case 49
                            sCardName = "AT88SC0104CRF"
                            Exit Select
                        Case 50
                            sCardName = "AT88SC0404CRF"
                            Exit Select
                        Case 51
                            sCardName = "AT88RF01C"
                            Exit Select
                        Case 52
                            sCardName = "AT88RF04C"
                            Exit Select
                        Case 53
                            sCardName = "i-Code SL2"
                            Exit Select
                        Case 54
                            sCardName = "Mifare Plus SL1_2K"
                            Exit Select
                        Case 55
                            sCardName = "Mifare Plus SL1_4K"
                            Exit Select
                        Case 56
                            sCardName = "Mifare Plus SL2_2K"
                            Exit Select
                        Case 57
                            sCardName = "Mifare Plus SL2_4K"
                            Exit Select
                        Case 58
                            sCardName = "NTAG203"
                            'sCardName = "Mifare Ultralight C"
                            Exit Select
                        Case 59
                            sCardName = "FeliCa"
                            Exit Select
                        Case 60
                            sCardName = "Melexis Sensor Tag (MLX90129)"
                            Exit Select
                        Case 61
                            sCardName = "Mifare Ultralight EV1"
                            Exit Select
                        Case Else
                            sCardName = "Unknown"
                            Exit Select
                    End Select
                Else
                    sCardName = "Unknown"
                End If
            Else
                ' Part 4
                If atr(4) = &H0 Then

                Else
                    Try
                        'Send FF CA 01 00 00 to determine if Type A or Type B
                        'Success = Type A
                        'Fail = Type B
                        Return getUid()
                    Catch pcscException As PcscException
                        Throw pcscException
                    End Try
                End If
            End If

            Return sCardName
        End Function

        Private Function getUid() As String
            Dim aResponse As Byte() = New Byte(99) {}
            Dim aCommand As Byte() = New Byte() {&HFF, &HCA, &H1, &H0, &H0}
            Dim aStatusWord As Byte() = New Byte(1) {}

            Dim cApdu As New Apdu()

            Try
                cApdu.setCommand(aCommand)
                cApdu.lengthExpected = 255

                Me.pcscReader_.sendCommand(cApdu)

                If cApdu.statusWord(0) = &H6A Then
                    ' Type B
                    Return "ISO 14443 Part 4 Type B"
                Else
                    ' ISO 14443 Part 4 Type A; includes ACOS cards
                    Return "ISO 14443 Part 4 Type A"
                End If
            Catch cException As CardException
                Throw cException
            Catch cException As PcscException
                Throw cException
            End Try

        End Function
    End Class
End Namespace


