﻿Imports Mifare_NDEF_Sample_Code.Acs.Readers.Pcsc

Public Class Ntag203
    Private _pcscConnection As PcscReader

    Public Sub New(ByVal readerName As String)
        _pcscConnection = New PcscReader(readerName)
    End Sub

    Public Sub New(ByVal pcsc As PcscReader)
        _pcscConnection = pcsc
    End Sub

    Public Property pcscConnection() As PcscReader
        Get
            Return _pcscConnection
        End Get
        Set(ByVal value As PcscReader)
            _pcscConnection = value
        End Set
    End Property

    Private Function getErrorMessage(ByVal sw1sw2 As Byte()) As String
        If sw1sw2.Length < 2 Then
            Return "Unknown Status Word (" + Helper.byteAsString(sw1sw2, False) + ")"

        ElseIf sw1sw2(0) = &H63 AndAlso sw1sw2(1) = &H0 Then
            Return "Command failed"
        Else
            Return "Unknown Status Word (" + Helper.byteAsString(sw1sw2, False) + ")"
        End If
    End Function

    Public Function readBinary(ByVal blockNumber As Byte, ByVal length As Byte) As Byte()
        Dim apdu As Acs.Readers.Pcsc.Apdu

        apdu = New Acs.Readers.Pcsc.Apdu()
        apdu.setCommand(New Byte() {&HFF, &HB0, &H0, blockNumber, length})
        apdu.data = New Byte(-1) {}
        apdu.lengthExpected = length

        pcscConnection.sendCommand(apdu)
        If apdu.statusWord(0) <> &H90 Then
            Throw New CardException("Read failed", apdu.statusWord)
        End If

        Return apdu.response.Take(length).ToArray()
    End Function

    Public Sub updateBinary(ByVal blockNumber As Byte, ByVal data As Byte(), ByVal length As Byte)
        Dim apdu As Acs.Readers.Pcsc.Apdu

        If data.Length <> length Then
            Throw New Exception("Data has invalid length")
        End If

        If length Mod 4 <> 0 Then
            Throw New Exception("Data length must be multiple of 4")
        End If

        apdu = New Acs.Readers.Pcsc.Apdu()
        apdu.setCommand(New Byte() {&HFF, &HD6, &H0, blockNumber, length})

        apdu.data = New Byte(data.Length - 1) {}
        Array.Copy(data, apdu.data, length)

        pcscConnection.sendCommand(apdu)

        If apdu.statusWord(0) <> &H90 Then
            Throw New CardException("Update failed", apdu.statusWord)
        End If
    End Sub
End Class
